package org.framework.lazy.cloud.network.heartbeat.server.standalone.application;

import org.wu.framework.web.response.Result;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.domain.model.lazy.netty.client.permeate.client.mapping.LazyNettyClientPermeateClientMapping;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.client.mapping.LazyInternalNetworkClientPermeateClientMappingRemoveCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.client.mapping.LazyInternalNetworkClientPermeateClientMappingStoryCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.client.mapping.LazyInternalNetworkClientPermeateClientMappingUpdateCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.client.mapping.LazyInternalNetworkClientPermeateClientMappingQueryListCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.client.mapping.LazyInternalNetworkClientPermeateClientMappingQueryOneCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.dto.LazyInternalNetworkClientPermeateClientMappingDTO;
import java.util.List;
import org.wu.framework.lazy.orm.database.lambda.domain.LazyPage;
/**
 * describe 客户端渗透客户端映射 
 *
 * @author Jia wei Wu
 * @date 2024/09/17 09:55 晚上
 * @see org.wu.framework.lazy.orm.core.persistence.reverse.lazy.ddd.DefaultDDDLazyApplication 
 **/

public interface LazyInternalNetworkClientPermeateClientMappingApplication {


    /**
     * describe 新增客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingStoryCommand 新增客户端渗透客户端映射     
     * @return {@link Result< LazyNettyClientPermeateClientMapping >} 客户端渗透客户端映射新增后领域对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result<LazyNettyClientPermeateClientMapping> story(LazyInternalNetworkClientPermeateClientMappingStoryCommand lazyInternalNetworkClientPermeateClientMappingStoryCommand);

    /**
     * describe 批量新增客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingStoryCommandList 批量新增客户端渗透客户端映射     
     * @return {@link Result<List< LazyNettyClientPermeateClientMapping >>} 客户端渗透客户端映射新增后领域对象集合
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result<List<LazyNettyClientPermeateClientMapping>> batchStory(List<LazyInternalNetworkClientPermeateClientMappingStoryCommand> lazyInternalNetworkClientPermeateClientMappingStoryCommandList);

    /**
     * describe 更新客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingUpdateCommand 更新客户端渗透客户端映射     
     * @return {@link Result< LazyNettyClientPermeateClientMapping >} 客户端渗透客户端映射领域对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result<LazyNettyClientPermeateClientMapping> updateOne(LazyInternalNetworkClientPermeateClientMappingUpdateCommand lazyInternalNetworkClientPermeateClientMappingUpdateCommand);

    /**
     * describe 查询单个客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingQueryOneCommand 查询单个客户端渗透客户端映射     
     * @return {@link Result<LazyInternalNetworkClientPermeateClientMappingDTO>} 客户端渗透客户端映射DTO对象     
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result<LazyInternalNetworkClientPermeateClientMappingDTO> findOne(LazyInternalNetworkClientPermeateClientMappingQueryOneCommand lazyInternalNetworkClientPermeateClientMappingQueryOneCommand);

    /**
     * describe 查询多个客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingQueryListCommand 查询多个客户端渗透客户端映射     
     * @return {@link Result <List<LazyInternalNetworkClientPermeateClientMappingDTO>>} 客户端渗透客户端映射DTO对象     
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result <List<LazyInternalNetworkClientPermeateClientMappingDTO>> findList(LazyInternalNetworkClientPermeateClientMappingQueryListCommand lazyInternalNetworkClientPermeateClientMappingQueryListCommand);

    /**
     * describe 分页查询多个客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingQueryListCommand 分页查询多个客户端渗透客户端映射     
     * @return {@link Result <LazyPage<LazyInternalNetworkClientPermeateClientMappingDTO>>} 分页客户端渗透客户端映射DTO对象     
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result <LazyPage<LazyInternalNetworkClientPermeateClientMappingDTO>> findPage(int size,int current,LazyInternalNetworkClientPermeateClientMappingQueryListCommand lazyInternalNetworkClientPermeateClientMappingQueryListCommand);

    /**
     * describe 删除客户端渗透客户端映射
     *
     * @param lazyInternalNetworkClientPermeateClientMappingRemoveCommand 删除客户端渗透客户端映射     
     * @return {@link Result< LazyNettyClientPermeateClientMapping >} 客户端渗透客户端映射
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:55 晚上
     **/

    Result<LazyNettyClientPermeateClientMapping> remove(LazyInternalNetworkClientPermeateClientMappingRemoveCommand lazyInternalNetworkClientPermeateClientMappingRemoveCommand);

}